Bug 46785 - Child process increases to 100% (CPU)
Summary: Child process increases to 100% (CPU)
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: All (show other bugs)
Version: 2.2.3
Hardware: PC Linux
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2009-03-02 03:20 UTC by Carlos Marinho
Modified: 2018-11-07 21:08 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Carlos Marinho 2009-03-02 03:20:45 UTC
Using Apache 2.2.3 acting as a proxy, renamed here as wap2d, i'm getting some process at 100% of CPU.

Some times it crashes at apr_brigade_cleanup () and others at apr_bucket_destroy_noop () (see gdb backtrace bellow).

Other times i get a segmentation fault but the core dump file says the same.

I hope that someone can help.

Here is the gdb backtrace:

Reading symbols from /usr/lib/httpd/modules/ptin_proxy_wap2_profiles.so...done.
Loaded symbols for /etc/httpd/modules/ptin_proxy_wap2_profiles.so
Reading symbols from /usr/lib/httpd/modules/ptin_proxy_wap2_http.so...done.
Loaded symbols for /etc/httpd/modules/ptin_proxy_wap2_http.so
Reading symbols from /usr/lib/httpd/modules/mod_proxy_connect.so...done.
Loaded symbols for /etc/httpd/modules/mod_proxy_connect.so
Reading symbols from /usr/lib/httpd/modules/mod_charset_lite.so...done.
Loaded symbols for /etc/httpd/modules/mod_charset_lite.so
Reading symbols from /usr/lib/httpd/modules/mod_substitute.so...done.
Loaded symbols for /etc/httpd/modules/mod_substitute.so
Reading symbols from /lib/libnss_dns.so.2...done.
Loaded symbols for /lib/libnss_dns.so.2
0x00fe8140 in apr_bucket_destroy_noop ()
   from /usr/lib/libaprutil-1.so.0
(gdb) where
#0  0x00fe8140 in apr_bucket_destroy_noop () from /usr/lib/libaprutil-1.so.0
#1  0x00fe84ef in apr_brigade_cleanup () from /usr/lib/libaprutil-1.so.0
#2  0x00fe852d in apr_brigade_cleanup () from /usr/lib/libaprutil-1.so.0
#3  0x0033cc7d in apr_pool_cleanup_run () from /usr/lib/libapr-1.so.0
#4  0x0033d5c7 in apr_pool_clear () from /usr/lib/libapr-1.so.0
#5  0x00736714 in ap_graceful_stop_signalled () from /usr/sbin/wap2d
#6  0x00736bf1 in ap_graceful_stop_signalled () from /usr/sbin/wap2d
#7  0x00736cca in ap_graceful_stop_signalled () from /usr/sbin/wap2d
#8  0x0073782b in ap_mpm_run () from /usr/sbin/wap2d
#9  0x0070e127 in main () from /usr/sbin/wap2d
(gdb) up
#1  0x00fe84ef in apr_brigade_cleanup () from /usr/lib/libaprutil-1.so.0
(gdb) up
#2  0x00fe852d in apr_brigade_cleanup () from /usr/lib/libaprutil-1.so.0
(gdb) up
#3  0x0033cc7d in apr_pool_cleanup_run () from /usr/lib/libapr-1.so.0
(gdb) up
#4  0x0033d5c7 in apr_pool_clear () from /usr/lib/libapr-1.so.0
(gdb) up
#5  0x00736714 in ap_graceful_stop_signalled () from /usr/sbin/wap2d
(gdb) up
#6  0x00736bf1 in ap_graceful_stop_signalled () from /usr/sbin/wap2d
(gdb) up
#7  0x00736cca in ap_graceful_stop_signalled () from /usr/sbin/wap2d
(gdb) up
#8  0x0073782b in ap_mpm_run () from /usr/sbin/wap2d
(gdb) up
#9  0x0070e127 in main () from /usr/sbin/wap2d
(gdb) up




Here is my config:

wap2d -M
Loaded Modules:
 core_module (static)
 mpm_prefork_module (static)
 http_module (static)
 so_module (static)
 auth_basic_module (shared)
 auth_digest_module (shared)
 authn_file_module (shared)
 authn_alias_module (shared)
 authn_anon_module (shared)
 authn_dbm_module (shared)
 authn_default_module (shared)
 authz_host_module (shared)
 authz_user_module (shared)
 authz_owner_module (shared)
 authz_groupfile_module (shared)
 authz_dbm_module (shared)
 authz_default_module (shared)
 ldap_module (shared)
 authnz_ldap_module (shared)
 include_module (shared)
 log_config_module (shared)
 logio_module (shared)
 env_module (shared)
 ext_filter_module (shared)
 mime_magic_module (shared)
 expires_module (shared)
 deflate_module (shared)
 headers_module (shared)
 usertrack_module (shared)
 setenvif_module (shared)
 mime_module (shared)
 dav_module (shared)
 status_module (shared)
 autoindex_module (shared)
 info_module (shared)
 dav_fs_module (shared)
 vhost_alias_module (shared)
 negotiation_module (shared)
 dir_module (shared)
 actions_module (shared)
 speling_module (shared)
 userdir_module (shared)
 alias_module (shared)
 rewrite_module (shared)
 proxy_module (shared)
 proxy_balancer_module (shared)
 proxy_ftp_module (shared)
 proxy_http_module (shared)
 proxy_connect_module (shared)
 cache_module (shared)
 suexec_module (shared)
 disk_cache_module (shared)
 file_cache_module (shared)
 mem_cache_module (shared)
 cgi_module (shared)
 version_module (shared)
 proxy_ajp_module (shared)
 ssl_module (shared)

Regards,
Carlos Marinho
Comment 1 Dan Poirier 2009-03-20 10:18:05 UTC
I suggest moving to the current release (2.2.11 at the moment).  If you still have problems, try commenting out all the modules you're not using.  If that doesn't help, you'll probably have to provide your exact configuration and detailed instructions for recreating the problem for someone to be able to help. 

All I can tell from the stack trace is that something probably corrupted memory at some time in the past, and apache tripped over it when it tried to clean up during a normal shutdown.  So you might be able to catch the problem by building APR with malloc and pool debugging enabled.
Comment 2 William A. Rowe Jr. 2018-11-07 21:08:41 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.